'**********************************************************
' C-Control Station
'
' Beispiel - die Folien-Tasten zur Auswahl einer
' Betriebsart im Anwenderprogramm
'
' ein Programm soll 4 Betriebsarten zum Schalten von
' Relais K1 haben:
' mode0 - Relais aus
' mode1 - K1 schaltet im 5s-Takt
' mode2 - K1 schaltet jede Minute fuer 10s ein
' mode3 - manueller Modus, K1 wird nach jedem Tastendruck
'         fuer 20s eingeschaltet
'
' Simulatortip: aktivieren Sie das Digitalports-Fenster
' und die Ueberwachten Variablen, ueberwachen Sie den
' Wert von second und offtime
'**********************************************************

' --- Definitionen ---

' das Relais
define K1 port[7]

' die Folien-Funktionstasten
define F1 port[9]
define F2 port[10]
define F3 port[11]
define F4 port[12]

' die LEDs
define LED1 port[13]
define LED2 port[14]
define LED3 port[15]
define LED4 port[16]

' Definition zweier Byte-Variablen
define mode byte
define offtime byte


' --- das Programm ---

' Initialisierung
gosub activateMode0

' Endlosschleife
#loop

  ' Tastenabfrage
  if not F1 then gosub activateMode0
  if not F2 then gosub activateMode1
  if not F3 then gosub activateMode2
  if not F4 then gosub activateMode3

  ' Betrieb in Abhaengigkeit vom Modus
  on mode gosub mode0, mode1, mode2, mode3

goto loop

' Relais-Betrieb
#mode0
  K1 = OFF
return

#mode1
  K1 = (second mod 10) < 5
return

#mode2
  K1 = second < 10
return

#mode3
  if second = offtime then K1 = OFF
return

' Initialisierungen der einzelnen Betriebsarten
#activateMode0
 beep 250,5,0    ' die Dauer des Quittungstons entprellt die Taste
 gosub LEDsOFF   ' alle LEDs aus
 LED1 = ON       ' LED1 einschalten
 wait F1         ' warten, bis Taste losgelassen
 mode = 0        ' Betriebsart auswaehlen
return

#activateMode1
 beep 200,5,0
 gosub LEDsOFF
 LED2 = ON
 wait F2
 mode = 1
return

#activateMode2
 beep 150,5,0
 gosub LEDsOFF
 LED3 = ON
 wait F3
 mode = 2
return

#activateMode3
 beep 100,5,0
 gosub LEDsOFF
 LED4 = ON
 wait F4
 mode = 3
 K1 = ON
 offtime = (second + 20) mod 60
return


#LEDsOFF
  LED1 = OFF
  LED2 = OFF
  LED3 = OFF
  LED4 = OFF
return
