'**********************************************************
' C-Control Station
'
' Beispiel - "Ich bin da!"-Simulator
'
' Die C-Control Station soll die Anwesenheit von Personen
' in einer Wohnung simulieren, um beispielsweise potentielle
' Langfinger abzuschrecken. Das Beispiel dient zur
' Demonstration der Uhrzeit-Auswertung und der
' Zufallsfunktion. Am DCF77-Port der Station sei eine
' DCF77-Aktivantenne (Conrad Best.-Nr. 64 11 46) angeschlossen,
' ber das Relais K1 soll ein Fernseher, ber K2 eine Lampe
' geschalten werden. Das System soll durch Tastendruck auf
' die Folientaste F1 aktiviert und deaktiviert werden. Den
' Aktivzustand zeigt LED1 an.
'
'**********************************************************

' --- Definitionen ---

' die Relais
define TV port[7]
define LAMP port[8]

' Taste und LED
define F1 port[9]
define LED1 port[13]

' Variablen
define tvOnMinute byte
define tvOffMinute byte
define lampOnMinute byte
define lampOffMinute byte

' symbolische Konstanten
define YES ON
define NO OFF


' --- das Programm ---

' Initialisierung
TV = OFF
LAMP = OFF

' Endlosschleife
#loop

  if not F1 then gosub togglemode
  if not LED1 then goto loop

  if isTvOnTime then TV = ON
  if isTvOffTime then TV = OFF
  if isLampOnTime then LAMP = ON
  if isLampOffTime then LAMP = OFF

goto loop


' Fernseher ab 19.xx Uhr einschalten, xx zuflliger Minutenwert
#isTvOnTime
  if (hour >= 19) and (minute = tvOnMinute) then return YES else return NO

' Fernseher ab 22.xx Uhr ausschalten, xx zuflliger Minutenwert
#isTvOffTime
  if (hour >= 22) and (minute = tvOffMinute) then return YES else return NO

' ab 18 Uhr immer mal die Lampe einschalten
#isLampOnTime
  if LAMP then return NO
  if (hour < 18) or (minute <> lampOnMinute) then return NO
  lampOffMinute = (minute + abs(rand) + 1) mod 60
return YES

' nach ein paar Minuten wieder ausschalten
#isLampOffTime
  if not LAMP then return NO
  if (minute <> lampOffMinute) then return NO
  lampOnMinute = (minute + abs(rand) + 1) mod 60
return YES


#togglemode

  pause 5
  wait F1
  if LED1 then goto deactivate
  LED1 = ON
  randomize timer
  tvOnMinute = abs(rand) mod 60
  tvOffMinute = abs(rand) mod 60
  lampOnMinute = abs(rand) mod 60
return


#deactivate
  TV = OFF
  LAMP = OFF
  LED1 = OFF
return

